* --------------------------------------------------------------------------- *
*					      encore un FISC/SKID-ROW boot!!! *
*						      written by FLASHER JACK *
* --------------------------------------------------------------------------- *
* Pour installer (AsmOne):
*	WS<RET>
*	location<RET>
*	0<RET>
*	2<RET>
*	CC<RET>
* --------------------------------------------------------------------------- *

* ---------------------------------------------------------------- constantes *
location		equ	$3a000
execbase		equ	4

* -------------------------------------------- localisation du prg en memoire *
			jmp	location
			org	location
			load	location

* -------------------------------------------------------------- debut du prg *
debut:			dc.b	"DOS",0			* flag d'un boot normal
			dc.l	0			* emplacement checksum
			dc.l	880			* block 880 (rootblock)
			bra.b	set
credits			dc.b	"CODED BY FLASHER JACK!"
set			movem.l	d0-a6,-(a7)
			lea.l	debut(pc),a1
			bset.b	#1,$bfe001
			lea.l	$dff002,a5
			move.w	(a5),d0
			or.w	d0,savedma+2-debut(a1)
			lea.l	$60000,a6

* ---------------------------- copie du debut de la table et efface les plans *
			lea.l	$40000,a0
			lea.l	sin-debut(a1),a3
			lea.l	(a6),a2
vide			clr.l	(a2)
			moveq.l	#0,d0			* cela vaut +
			move.b	(a3)+,d0		* q'1 ext.w
			move.w	d0,(a2)+		* (mais - qu'1
			clr.l	(a0)+			* steack de 100g)
			cmp.l	a6,a0
			bcs.b	vide
			lea.l	$68000,a0
double_vide		clr.l	(a0)+
			cmp.l	#$78000,a0
			bcs.b	double_vide

* --------- copie de la table en sens inverse (pour 1 table de sinus entiere) *
			lea.l	512(a6),a0
			lea.l	-2(a0),a3
			move.w	#512-1,d7
copy_sin		move.w	-(a0),(a3)+
			dbf	d7,copy_sin

* ------------------ copie de la table (entiere) et transformation en cosinus *
* --------------------------------------------------- (cosinus=sinus inverse) *
			lea.l	(a6),a0
			lea.l	1024(a0),a3
			move.w	#1024-1,d7
negative_sin		move.w	(a0)+,d0
			neg.w	d0
			move.w	d0,(a3)+
			dbf	d7,negative_sin

* ------------ copie de la table 1 deuxieme fois pour eviter les debordements *
			lea.l	(a6),a0
			lea.l	2048(a0),a3
			move.w	#1024-1,d7
recopy_sin		move.w	(a0)+,(a3)+
			dbf	d7,recopy_sin

* ----------------------------- definition aleatoire des positions des points *
			lea.l	blocketoiles-debut(a1),a0
			moveq.l	#128-1,d0		* 128 etoiles
			move.w	#$5740,d2
init			add.w	6-2(a5),d1
			eor.w	d2,d1
			ror.w	#5,d1
			move.w	d1,(a0)+		* x
			add.w	6-2(a5),d1
			eor.w	d2,d1
			ror.w	#5,d1
			move.w	d1,(a0)+		* y
			add.w	6-2(a5),d1
			eor.w	d2,d1
			ror.w	#5,d1
			move.w	d1,(a0)+		* z1
			clr.w	(a0)+			* z2 (ancien z)
			dbf	d0,init

* ---------------------------------------------------------- copie de l'image *
			lea.l	$68000+22+(136*80),a0
			lea.l	image-debut(a1),a2
			moveq.l	#5-1,d7
copy			move.b	(a2)+,(a0)+
			move.b	(a2)+,(a0)+
			move.b	(a2)+,(a0)+
			move.b	(a2)+,(a0)+
			move.b	(a2)+,(a0)+
			move.b	(a2)+,(a0)
			lea.l	80-5(a0),a0
			dbf	d7,copy

* ----------------------------------------------------- definition de l'ecran *
			lea.l	copper-debut(a1),a0
			move.l	a0,$80-2(a5)
			lea.l	souris-debut(a1),a0
			move.l	a0,$84.w		* passe en superviseur
			trap	#1			* + vire la multitache

* ------------------------------------------- retour a l'ecran l'ancien ecran *
savedma			move.w	#$8000,$96-2(a5)
			move.l	(execbase).w,a6
			move.l	156(a6),a6
			move.l	38(a6),$80-2(a5)
			movem.l	(a7)+,d0-a6

* --------------------------------------------- cherche le programme resident *
			lea.l	dosname(pc),a1
			jsr	-96(a6)
			move.l	d0,a0
			move.l	22(a0),a0
			moveq.l	#0,d0
			rts

* ------------------------------------------------------------- boucle du prg *
souris			cmp.b	#80,6-2(a5)
			bne.b	souris

* ------------------------------------------------------- routine des etoiles *
			move.l	#etoiles,d0
			lea.l	etoilesbps+2-debut(a1),a0
			move.w	d0,(a0)
			add.w	#(300*80),d0
			move.w	d0,4(a0)
			lea.l	(a6),a4
			lea.l	512(a4),a3
			lea.l	angle-debut(a1),a2
			addq.w	#6,(a2)			* et tournez...

* ------------------- 2046 valeurs au maximimum (attention:masque binaire!!!) *
			and.w	#$7fe,(a2)
			move.w	(a2)+,d0		* +2 pour la vitesse
			move.w	(a4,d0.w),sin_z+2-debut(a1)
			move.w	(a3,d0.w),cos_z+2-debut(a1)

			addq.w	#2,(a2)			* vitesse=2
			lea.l	etoiles,a3
			lea.l	(300*80)(a3),a4
			lea.l	blocketoiles-debut(a1),a0
			moveq.l	#128-1,d7		* 128 etoiles

copy_etoiles		movem.w	(a0)+,d0-d2
			move.w	(a0),d4
			sf.b	(a3,d4.w)		* efface les etoiles
			sf.b	(a4,d4.w)		* apres leur passage

* --------------------------------------- calcul de l'angle z pour 1 rotation *
* pour suprimer les lsr.l (et augmenter la rapidite de la routine) 	      *
* il vous suffit d'augmenter les valeurs de la table			      *
* pour arriver a 1 division de 1024 (ce qui correspond a 1 swap.w) 	      *
* mettre les swap.w avant l'addition et la soustraction sinon il vous 	      *
* faudra utiliser 32 bits (.l) 						      *
sin_z			move.w	#0,d5
cos_z			move.w	#0,d6
			move.w	d0,d3			* x=x
			move.w	d1,d4			* y=y
			muls.w	d6,d0			* cos(x)
			muls.w	d6,d1			* cos(y)
			muls.w	d5,d3			* sin(x)
			muls.w	d5,d4			* sin(y)
			moveq.l	#9,d5
			lsr.l	d5,d0			* (cos(x)/512)
			lsr.l	d5,d3			* (sin(x)/512)
			lsr.l	d5,d4			* (sin(y)/512)
			lsr.l	d5,d1			* (cos(y)/512)
			sub.w	d4,d0			* (sin(y)-(cos(x)
			add.w	d3,d1			* (sin(x)+(cos(y)

* --------------------------------------------------------- bouge les etoiles *
			sub.w	(a2),d2
			and.w	#$1fe,d2		* valeur maximale
			beq.b	plan1

			ext.l	d0			* ceci permet de signer
			ext.l	d1			* x et y (16->32)

* --- x et y sont divises par la position du compteur de vitesse(perspective) *
* --------------------- (+ le compteur est grand + les etoiles sont ecartees) *
			divs.w	d2,d0
			divs.w	d2,d1
			add.w	#190,d0			* centre x
			add.w	#136,d1			* centre y
			cmp.w	#639,d0			* limite x
			bcc.b	plan1
			cmp.w	#300,d1			* limite y
			bcc.b	plan1
			move.w	d0,d3
			lsr.w	#3,d0
			not.b	d3
			mulu.w	#80,d1			* beurk!
			add.w	d1,d0
			move.w	d0,(a0)
			cmp.w	#270,d2			* profondeur du pl3
			bls.b	plan3
			bset.b	d3,(a3,d0.w)		* plans
			bset.b	d3,(a4,d0.w)		* 1+2
			bra.b	plan1
plan3			cmp.w	#150,d2			* profondeur du pl2
			bls.b	plan2
			bset.b	d3,(a4,d0.w)
			bra.b	plan1
plan2			bset.b	d3,(a3,d0.w)		* le pl1 est devant!
plan1			addq.w	#2,a0
			dbf	d7,copy_etoiles

* --------------------------------------- attend le click gauche de la souris *
			btst.b	#6,$bfe001
			bne.w	souris
			rte

* ----------------------------------------------------------------- variables *
copper			dc.w	$8e,$1c81,$90,$35ff
			dc.w	$92,$28,$94,$e0,$140,0
			dc.w	$96,$20,$96,$87c0
			dc.w	$100,$3600
			dc.w	$102,4,$104,$40
			dc.w	$108,40-6,$10a,40-6
			dc.w	$180,$102,$182,$aaa,$184,$666,$186,$333
			dc.w	$192,$aaf
			dc.w	$e0,5,$e8,5
etoilesbps		dc.w	$e2,0,$ea,0
			dc.w	$e4,6,$e6,$8000
			dc.w	$a009,-2,$180,$fff,$182,$fff,$184,$fff,$186,$fff
			dc.w	$a109,-2,$180,$203,$182,$203,$184,$203,$186,$203
			dc.w	$ac09,-2,$180,$fff,$182,$fff,$184,$fff,$186,$fff
			dc.w	$ad09,-2,$180,$102,$182,$aaa,$184,$666,$186,$333
			dc.l	-2
dosname			dc.b	"dos.library",0
calmos			dc.b	4
flag			dc.b	0
angle			dc.w	0
vitesse			dc.w	0
pos			dc.w	0
image			dc.w	%1110101110111000,%0011101010101100,%0000111011101010
			dc.w	%1000101000100000,%1010001010101010,%0000101010101010
			dc.w	%1100101110100001,%0011101100101010,%1110110010101010
			dc.w	%1000100010100010,%0000101010101010,%0000101010101110
			dc.w	%1000101110111000,%0011101010101100,%0000101011101010

* --------------------------------------------------------------------- datas *
datas
blocketoiles		equ	$40000
etoiles			equ	$50000

* --------------------------------------------------- la demi table des sinus *
sin			dc.b	0,1,3,4,6,7,9,$a,$c,$e,$f,$11,$12,$14,$15,$17
			dc.b	$19,$1a,$1c,$1d,$1f,$20,$22,$24,$25,$27,$28
			dc.b	$2a,$2b,$2d,$2e,$30,$31,$33,$35,$36,$38,$39
			dc.b	$3b,$3c,$3e,$3f,$41,$42,$44,$45,$47,$48,$4a
			dc.b	$4b,$4d,$4e,$50,$51,$53,$54,$56,$57,$59,$5a
			dc.b	$5c,$5d,$5f,$60,$61,$63,$64,$66,$67,$69,$6a
			dc.b	$6c,$6d,$6e,$70,$71,$73,$74,$75,$77,$78,$7a
			dc.b	$7b,$7c,$7e,$7f,$80,$82,$83,$84,$86,$87,$88
			dc.b	$8a,$8b,$8c,$8e,$8f,$90,$92,$93,$94,$95,$97
			dc.b	$98,$99,$9b,$9c,$9d,$9e,$9f,$a1,$a2,$a3,$a4
			dc.b	$a6,$a7,$a8,$a9,$aa,$ab,$ad,$ae,$af,$b0,$b1
			dc.b	$b2,$b3,$b5,$b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd
			dc.b	$be,$bf,$c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8
			dc.b	$c9,$ca,$cb,$cc,$cd,$ce,$cf,$d0,$d1,$d2,$d3
			dc.b	$d3,$d4,$d5,$d6,$d7,$d8,$d9,$d9,$da,$db,$dc
			dc.b	$dd,$dd,$de,$df,$e0,$e1,$e1,$e2,$e3,$e3,$e4
			dc.b	$e5,$e6,$e6,$e7,$e8,$e8,$e9,$ea,$ea,$eb,$eb
			dc.b	$ec,$ed,$ed,$ee,$ee,$ef,$ef,$f0,$f1,$f1,$f2
			dc.b	$f2,$f3,$f3,$f4,$f4,$f4,$f5,$f5,$f6,$f6,$f7
			dc.b	$f7,$f7,$f8,$f8,$f9,$f9,$f9,$fa,$fa,$fa,$fb
			dc.b	$fd,$fd,$fd,$fc,$fc,$fc,$fc,$fd,$fd,$fd,$fd
			dc.b	$fe,$fe,$fe,$fe,$fe,$fe,$ff,$ff,$ff,$ff,$ff
			dc.b	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
fin			end
